//------------------------------------------------------------------------
// Color-fire-explosion-thing by Andreas Gustafsson (Shadow/Noice) (C)1999
//------------------------------------------------------------------------
#include "stdafx.h"
#include "Texture.h"

#define NR_WAVES 24

//----------------------------------------
// Usefull debugger thingy.
void DebugOut(const char *szFormat, ...);
//----------------------------------------

// Change your App Name.
char szAppName[] = "Colorfire by Andreas Gustafsson (Shadow/Noice) (C)1999";

// Timer info.  Very useful for keeping animated stuff in sync on different computers.
extern float fTime, fDeltaTime;

// Current window dimensions.
extern GLsizei g_w, g_h;

CTexture gTexExample;

float wrot[NR_WAVES],wtime[NR_WAVES],wr[NR_WAVES],wg[NR_WAVES],wb[NR_WAVES],wspd[NR_WAVES],wmax[NR_WAVES];
float v1=0,v2=0,v3=0;

float random(float high)
{
    return((float)((double)rand()/32768)*high);
}

void initWave(int nr)
{
	wtime[nr]=0;
	wrot[nr]=random(360);
	wr[nr]=random(1.0);
	wg[nr]=random(1.0);
	wb[nr]=random(1.0);
	wspd[nr]=0.5f+random(0.3f);
	wmax[nr]=1.0f+random(1.0f);
}

bool Init()	// Called right after the window is created, and OpenGL is initialized.
{
	int i;

	glViewport (0, 0, (GLsizei) g_w, (GLsizei) g_h); 
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	gluPerspective(55.0, (GLfloat) g_w/(GLfloat) g_h, 1.0, 20.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glTranslatef (0.0, 0.0, -3.0);
	glClearColor(0.0,0.0,0.0,0.0);

	for(i=0;i<NR_WAVES;i++) 
	{
		initWave(i);
		wtime[i]=3.0f+random(1.0f);
	}

	gTexExample.LoadJPG( "smoke.jpg" );
	gTexExample.Use(); // Tells OpenGL to use this texture.
	glEnable( GL_TEXTURE_2D );
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glEnable(GL_BLEND);
	return true;
}

void Shutdown() // Called right after the window is destroyed.
{
}

void drawWave(int nr)
{
	float colMod=1.0;

	glPushMatrix();
	glScalef(wtime[nr],wtime[nr],wtime[nr]);
	if(wtime[nr]>(wmax[nr]-1.0)) colMod=wmax[nr]-wtime[nr];
	glRotatef( wrot[nr], 1.f, 0, 0 );
	glRotatef( wrot[nr], 0, 1.f, 0 );
	glRotatef( wrot[nr], 0, 0, 1.f );
	glColor3f(colMod*wr[nr],colMod*wg[nr],colMod*wb[nr]);
	glBegin( GL_QUADS );
	glTexCoord2f( 0, 0 );
	glVertex3f(-1,-1,0);
	glTexCoord2f( 1, 0 );
	glVertex3f(1,-1,0);
	glTexCoord2f( 1, 1 );
	glVertex3f(1,1,0);
	glTexCoord2f( 0, 1 );
	glVertex3f(-1,1,0);
	glEnd();	
	wtime[nr]+=fDeltaTime*wspd[nr];
	if(wtime[nr]>wmax[nr]) initWave(nr);
	glPopMatrix();
}

void Render()
{
	int i;

	glClear( GL_COLOR_BUFFER_BIT );
	glPushMatrix();
	glRotatef(v1, 1.f, 0, 0 );
	glRotatef(v2, 0, 1.f, 0 );
	glRotatef(v3, 0, 0, 1.f );
	v1+=fDeltaTime*5;
	if(v1>360) v1-=360;
	v2+=fDeltaTime*10;
	if(v2>360) v2-=360;
	v3+=fDeltaTime*7;
	if(v3>360) v3-=360;
	for(i=0;i<NR_WAVES;i++) drawWave(i);
	glPopMatrix();	
}
